#include "bsp_bmp.h"
#include "ff.h"
#include "bsp_ili9341_lcd.h"

#define RGB24TORGB16(R,G,B) ((unsigned short int)((((R)>>3)<<11) | (((G)>>2)<<5)	| ((B)>>3)))

/* ҪӡbmpصʾϢ,printfע͵
 * Ҫprintf()轫ļ
 */
#define BMP_DEBUG_PRINTF(FORMAT,...)  //printf(FORMAT,##__VA_ARGS__)


BYTE pColorData[960];                   /* ʾBMPʱãһɫݻ 320 * 3 = 960 */
BYTE pColorDatapic[960];                /* ͼʱõģһɫݻ 320 * 3 = 960 */

//tagRGBQUAD dataOfBmp[17*19];
FATFS bmpfs[2]; 
FIL bmpfsrc, bmpfdst; 
FRESULT bmpres;

/* ӡBMPļͷϢڵ */
static void showBmpHead(BITMAPFILEHEADER* pBmpHead)
{
    BMP_DEBUG_PRINTF("λͼļͷ:\r\n");
    BMP_DEBUG_PRINTF("ļС:%d\r\n",(*pBmpHead).bfSize);
    BMP_DEBUG_PRINTF(":%d\r\n",(*pBmpHead).bfReserved1);
    BMP_DEBUG_PRINTF(":%d\r\n",(*pBmpHead).bfReserved2);
    BMP_DEBUG_PRINTF("ʵλͼݵƫֽ:%d\r\n",(*pBmpHead).bfOffBits);
		BMP_DEBUG_PRINTF("\r\n");	
}

/* ӡBMPļͷϢڵ */
static void showBmpInforHead(tagBITMAPINFOHEADER* pBmpInforHead)
{
    BMP_DEBUG_PRINTF("λͼϢͷ:\r\n");
    BMP_DEBUG_PRINTF("ṹĳ:%d\r\n",(*pBmpInforHead).biSize);
    BMP_DEBUG_PRINTF("λͼ:%d\r\n",(*pBmpInforHead).biWidth);
    BMP_DEBUG_PRINTF("λͼ:%d\r\n",(*pBmpInforHead).biHeight);
    BMP_DEBUG_PRINTF("biPlanesƽ:%d\r\n",(*pBmpInforHead).biPlanes);
    BMP_DEBUG_PRINTF("biBitCountɫλ:%d\r\n",(*pBmpInforHead).biBitCount);
    BMP_DEBUG_PRINTF("ѹʽ:%d\r\n",(*pBmpInforHead).biCompression);
    BMP_DEBUG_PRINTF("biSizeImageʵλͼռõֽ:%d\r\n",(*pBmpInforHead).biSizeImage);
    BMP_DEBUG_PRINTF("Xֱ:%d\r\n",(*pBmpInforHead).biXPelsPerMeter);
    BMP_DEBUG_PRINTF("Yֱ:%d\r\n",(*pBmpInforHead).biYPelsPerMeter);
    BMP_DEBUG_PRINTF("ʹõɫ:%d\r\n",(*pBmpInforHead).biClrUsed);
    BMP_DEBUG_PRINTF("Ҫɫ:%d\r\n",(*pBmpInforHead).biClrImportant);
		BMP_DEBUG_PRINTF("\r\n");
}

/*
 * ʾbmpͼƬ, 24λɫ 
 * ͼƬСܳ320*240
 */
void Lcd_show_bmp(unsigned short int x, unsigned short int y,unsigned char *pic_name)
{
	int i, j, k;
	int width, height, l_width;

	BYTE red,green,blue;
	BITMAPFILEHEADER bitHead;
	BITMAPINFOHEADER bitInfoHead;
	WORD fileType;

	unsigned int read_num;
	unsigned char tmp_name[20];
	sprintf((char*)tmp_name,"0:%s",pic_name);

	f_mount(0, &bmpfs[0]);
	BMP_DEBUG_PRINTF("file mount ok \r\n");    
	bmpres = f_open( &bmpfsrc , (char *)tmp_name, FA_OPEN_EXISTING | FA_READ);	

	if(bmpres == FR_OK)
	{
		BMP_DEBUG_PRINTF("Open file success\r\n");

		/* ȡλͼļͷϢ  ֽ*/         
		f_read(&bmpfsrc,&fileType,sizeof(WORD),&read_num);     

		/* жǲbmpļ */
		if(fileType != 0x4d42)
		{
			BMP_DEBUG_PRINTF("file is not .bmp file!\r\n");
			return;
		}
		else
		{
			BMP_DEBUG_PRINTF("Ok this is .bmp file\r\n");	
		}        

		/* ȡBMPļͷϢ*/
		f_read(&bmpfsrc,&bitHead,sizeof(tagBITMAPFILEHEADER),&read_num);        
		showBmpHead(&bitHead);

		/* ȡλͼϢͷϢ */
		f_read(&bmpfsrc,&bitInfoHead,sizeof(BITMAPINFOHEADER),&read_num);        
		showBmpInforHead(&bitInfoHead);
	}    
	else
	{
		BMP_DEBUG_PRINTF("file open fail!\r\n");
		return;
	}    

	width = bitInfoHead.biWidth;
	height = bitInfoHead.biHeight;

	/* λͼʵʿȲȷΪ32ı	*/
	l_width = WIDTHBYTES(width* bitInfoHead.biBitCount);		    

	if(l_width > 960)
	{
		BMP_DEBUG_PRINTF("\n SORRY, PIC IS TOO BIG (<=320)\n");
		return;
	}
	
	/* Lcd Gram ɨ跽Ϊ: ½->Ͻ */
	Lcd_GramScan( 3 );
	
	/* һͼƬСĴ*/
	LCD_OpenWindow(x, y, width, height);
	
	/* жǷ24bitɫͼ */
	if(bitInfoHead.biBitCount >= 24)
	{
		for(i=0;i< height; i++)
		{	  
			/* ȡһbmpݵpColorData */
			#if 0
				for(j=0; j< l_width; j++)	 													
				{                
					f_read(&bmpfsrc,pColorData+j,1,&read_num);
				}            
			#elif 1				
				f_read(&bmpfsrc,pColorData,l_width/2,&read_num);
				f_read(&bmpfsrc,pColorData+l_width/2,l_width/2,&read_num);
				#else
				f_read(&bmpfsrc,pColorData,l_width,&read_num);
			#endif

			for(j=0; j<width; j++) 											   //һЧϢ
			{
				k = j*3;																	 //һеKص
				red = pColorData[k+2];
				green = pColorData[k+1];
				blue = 	pColorData[k];
				LCD_WR_Data(RGB24TORGB16(red,green,blue)); //дLCD-GRAM
			}            
		}        	 																					     
	}    
	else 
	{        
		BMP_DEBUG_PRINTF("SORRY, THIS PIC IS NOT A 24BITS REAL COLOR");
	return ;
	}
	f_close(&bmpfsrc);    
}

/**********************************************************
 * Screen_shot
 *   ȡLCDָλ  ָߵ Ϊ24λɫbmpʽͼƬ
 *   : 	x								---ˮƽλ 
 *					y								---ֱλ  
 *					Width						---ˮƽ   
 *					Height					---ֱ߶  	
 *					filename				---ļ
 *   	0 		---ɹ
 *  				-1 		---ʧ
 *	    		8			---ļѴ
 *   Screen_shot(0, 0, 240, 320, "/myScreen");-----ȫͼ
 * ע  xΧ[0,239]  yΧ[0,319]  WidthΧ[0,240-x]  HeightΧ[0,320-y]
 *					ļѴ,ֱӷ	
 **************************************************************/ 
/*
 * bmpļͷ54ֽڣǰ14ֽļͷϢ40ֽλͼϢͷϢ
 * bmpļͷ֮ǾϢ
 * 0x42 0x4d :bm
 * 54        :ʵλͼݵƫֽ
 * 40        :λͼϢͷṹĳ
 * 1         :ƽΪ1
 * 24        :24bitɫ
 */
int Screen_shot(unsigned short int x,\
                unsigned short int y,\
                unsigned short int Width,\
                unsigned short int Height,\
                unsigned char *filename)
{
	/* bmp  ļͷ 54ֽ */
	unsigned char header[54] =
	{
		0x42, 0x4d, 0, 0, 0, 0, 
		0, 0, 0, 0, 54, 0, 
		0, 0, 40,0, 0, 0, 
		0, 0, 0, 0, 0, 0, 
		0, 0, 1, 0, 24, 0, 
		0, 0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0, 
		0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 
		0, 0, 0
	};
	
	int i;
	int j;
	long file_size;     
	long width;
	long height;
	unsigned char r,g,b;	
	unsigned int mybw;
	unsigned int read_data;
	char kk[4]={0,0,0,0};
	
	/* * +ֽ + ͷϢ */
	file_size = (long)Width * (long)Height * 3 + Height*(Width%4) + 54;		

	/* ļС 4ֽ */
	header[2] = (unsigned char)(file_size &0x000000ff);
	header[3] = (file_size >> 8) & 0x000000ff;
	header[4] = (file_size >> 16) & 0x000000ff;
	header[5] = (file_size >> 24) & 0x000000ff;
	
	/* λͼ 4ֽ */
	width=Width;	
	header[18] = width & 0x000000ff;
	header[19] = (width >> 8) &0x000000ff;
	header[20] = (width >> 16) &0x000000ff;
	header[21] = (width >> 24) &0x000000ff;
	
	/* λͼ 4ֽ */
	height = Height;
	header[22] = height &0x000000ff;
	header[23] = (height >> 8) &0x000000ff;
	header[24] = (height >> 16) &0x000000ff;
	header[25] = (height >> 24) &0x000000ff;
	
	/* עһ߼Ϊ0 */
	f_mount(0, &bmpfs[0]);
	
	bmpres = f_open(&bmpfsrc,(char*)filename, FA_CREATE_NEW|FA_WRITE);	
	f_close(&bmpfsrc); 
	bmpres = f_open(&bmpfsrc,(char*)filename,FA_OPEN_EXISTING|FA_WRITE);
	
	if ( bmpres == FR_OK )
	{    
		/* ԤȶõbmpͷϢдļ */
		bmpres = f_write(&bmpfsrc, header,sizeof(unsigned char)*54, &mybw);		
		
		/* ǽָڵݶдļȥ */
		for(i=0; i<Height; i++)					
		{
			if( !(Width%4) )				/* պ4ֽڶ */
			{
        #if 1
          for(j=0; j<Width; j++)  
          {					
            read_data = LCD_GetPoint(y+j, x+i);				
            
            r =  GETR_FROM_RGB16(read_data);
            g =  GETG_FROM_RGB16(read_data);
            b =  GETB_FROM_RGB16(read_data);

            bmpres = f_write(&bmpfsrc, &b,sizeof(unsigned char), &mybw);
            bmpres = f_write(&bmpfsrc, &g,sizeof(unsigned char), &mybw);
            bmpres = f_write(&bmpfsrc, &r,sizeof(unsigned char), &mybw);
          }
        #else
          LCD_GetLine_BGR24( y, x+i,Width,pColorDatapic);
          bmpres = f_write(&bmpfsrc, pColorDatapic,Width*3, &mybw);
          //bmpres = f_write(&bmpfsrc, pColorDatapic+Width,Width , &mybw);
          //bmpres = f_write(&bmpfsrc, pColorDatapic+2*Width,Width , &mybw);
        #endif
			}
			else
			{
				for(j=0;j<Width;j++)
				{					
					read_data = LCD_GetPoint(y+j, x+i);
					
					r =  GETR_FROM_RGB16(read_data);
					g =  GETG_FROM_RGB16(read_data);
					b =  GETB_FROM_RGB16(read_data);

					bmpres = f_write(&bmpfsrc, &b,sizeof(unsigned char), &mybw);
					bmpres = f_write(&bmpfsrc, &g,sizeof(unsigned char), &mybw);
					bmpres = f_write(&bmpfsrc, &r,sizeof(unsigned char), &mybw);
				}
				/* 4ֽڶҪ */	
				bmpres = f_write(&bmpfsrc, kk,sizeof(unsigned char)*(Width%4), &mybw);
			}	
		}/*  */

		f_close(&bmpfsrc); 
		return 0;
	}
	else if ( bmpres == FR_EXIST )  //ļѾ
	{
		return FR_EXIST;	 					//8
	}
	else/* ʧ */
	{
		return -1;
	}    
}

/* -------------------------------------end of file--------------------------------- */





