#ifndef __BSP_BMP_H
#define	__BSP_BMP_H

#include <string.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>


#define WIDTHBYTES(bits) (((bits)+31)/32*4)		//24λɫ ÿһеؿȱ4ı  0

typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
typedef long LONG;


//λͼļͷϢṹ
//вļϢڽṹڴṹҪǼ˵ĻȷȡļϢ
typedef struct tagBITMAPFILEHEADER 
{   
    DWORD bfSize; 															//ļС																				4
    WORD bfReserved1; 													//֣		 															2
    WORD bfReserved2; 													//֣ͬ			 															2
    DWORD bfOffBits; 														//ʵλͼݵƫֽǰֳ֮	4
} BITMAPFILEHEADER,tagBITMAPFILEHEADER;


typedef struct tagBITMAPINFOHEADER
{
    DWORD biSize; 														//ָ˽ṹĳȣΪ40		 												4
    LONG biWidth; 														//λͼ											 												4
    LONG biHeight; 														//λͼ											 												4
    WORD biPlanes; 														//ƽΪ1								 													2
    WORD biBitCount; 													//ɫλ12481624µĿ32	2
    DWORD biCompression; 											//ѹʽ0120ʾѹ						4
    DWORD biSizeImage; 												//ʵλͼռõֽ														4
    LONG biXPelsPerMeter; 										//Xֱ																					4
    LONG biYPelsPerMeter; 										//Yֱ																					4
    DWORD biClrUsed; 													//ʹõɫΪ0ʾĬֵ(2^ɫλ)			4
    DWORD biClrImportant; 										//ҪɫΪ0ʾɫҪ				4
} BITMAPINFOHEADER,tagBITMAPINFOHEADER;


typedef struct tagRGBQUAD 
{
    BYTE rgbBlue; 													//ɫɫ
    BYTE rgbGreen; 													//ɫɫ
    BYTE rgbRed; 														//ɫĺɫ
    BYTE rgbReserved;											 	//ֵ
} RGBQUAD,tagRGBQUAD;


typedef struct RGB_PIXEL
{      //ص
    unsigned char   rgbBlue;
    unsigned char   rgbGreen;
    unsigned char   rgbRed;
}RGB_PIXEL;


#define GETR_FROM_RGB16(RGB565)  ((unsigned char)(( ((unsigned short int )RGB565) >>11)<<3))		  			//8λ R
#define GETG_FROM_RGB16(RGB565)  ((unsigned char)(( ((unsigned short int )(RGB565 & 0x7ff)) >>5)<<2)) 	//8λ G
#define GETB_FROM_RGB16(RGB565)  ((unsigned char)(( ((unsigned short int )(RGB565 & 0x1f))<<3)))       	//8λ B
#pragma diag_suppress 870 	//ʹֶַֽ֧,invalid multibyte character sequence 



void Lcd_show_bmp(unsigned short int x, unsigned short int y,unsigned char *pic_name);
int Screen_shot(unsigned short int x,\
                unsigned short int y,\
                unsigned short int Width,\
                unsigned short int Height,\
                unsigned char *filename);


#endif /* __BSP_BMP_H */

